//
// Backgrounds
//


@each $color, $value in $colors {
  @include bg-variant(".bg-#{$color}", $value);
}

@each $color, $value in $theme-colors {
  @include bg-gradient-variant(".bg-gradient-#{$color}", $value);
}

@each $color, $value in $colors {
  @include bg-gradient-variant(".bg-gradient-#{$color}", $value);
}


// Background colors with transparency

@each $color, $value in $theme-colors {
  @include bg-translucent-variant(".bg-translucent-#{$color}", $value);
}


// Sections backgrounds

@each $color, $value in $section-colors {
  @include bg-variant(".section-#{$color}", $value);
}

@each $color, $value in $theme-colors {
  @include bg-gradient-variant(".bg-gradient-#{$color}", $value);
}


// Shape (svg) fill colors

@each $color, $value in $theme-colors {
  .fill-#{$color}  {
    fill: $value;
  }

  .stroke-#{$color}  {
    stroke: $value;
  }
}

.fill-opacity-8 {
  fill-opacity: .8;
}

//
// Floating
// floating animation utility class
//


.floating {
  animation: floating 3s ease infinite;
  will-change: transform;

  &:hover {
    animation-play-state: paused;
  }
}


// Size variations

.floating-lg {
  animation: floating-lg 3s ease infinite;
}

.floating-sm {
  animation: floating-sm 3s ease infinite;
}


// Keyframes

@keyframes floating-lg {
  0% {
    transform: translateY(0px)
  }
  50% {
    transform: translateY(15px)
  }
  100% {
    transform: translateY(0px)
  }
}

@keyframes floating {
  0% {
    transform: translateY(0px)
  }
  50% {
    transform: translateY(10px)
  }
  100% {
    transform: translateY(0px)
  }
}

@keyframes floating-sm {
  0% {
    transform: translateY(0px)
  }
  50% {
    transform: translateY(5px)
  }
  100% {
    transform: translateY(0px)
  }
}
//
// Helper
// helper classes for different cases
//


// Clearfix for sections that use float property

.floatfix {
  &:before,
  &:after {
    content: '';
    display: table;
  }
  &:after {
    clear: both;
  }
}
//
// Image
//

.img-center {
  display: block;
  margin-left: auto;
  margin-right: auto;
}
//
// Opacity
// modify the transparency of an element with this quick modifier classes
//

.opacity-1 {
  opacity: .1 !important;
}
.opacity-2 {
  opacity: .2 !important;
}
.opacity-3 {
  opacity: .3 !important;
}
.opacity-4 {
  opacity: .4 !important;
}
.opacity-5 {
  opacity: .5 !important;
}
.opacity-6 {
  opacity: .6 !important;
}
.opacity-7 {
  opacity: .7 !important;
}
.opacity-8 {
  opacity: .8 !important;
}
.opacity-8 {
  opacity: .9 !important;
}
.opacity-10 {
  opacity: 1 !important;
}
//
// Overflow
//

.overflow-visible {
  overflow: visible !important;
}

.overflow-hidden {
  overflow: hidden !important;
}
//
// Position
// modifier classes to be applied on an abosolute positioned element
// use it next to .position-absolute class
//

@each $size, $value in $spacers {
  .top-#{$size} {
    top: $value;
  }
  .right-#{$size} {
    right: $value;
  }
  .bottom-#{$size} {
    bottom: $value;
  }
  .left-#{$size} {
    left: $value;
  }
}

.center {
  left: 50%;
  transform: translateX(-50%);
}
//
// Height
//

.h-100vh {
  height: 100vh !important;
}
//
// Spacing
//

.row.row-grid > [class*="col-"] + [class*="col-"] {
  margin-top: 3rem;
}

@include media-breakpoint-up(lg) {
  .row.row-grid > [class*="col-lg-"] + [class*="col-lg-"] {
    margin-top: 0;
  }
}
@include media-breakpoint-up(md) {
  .row.row-grid > [class*="col-md-"] + [class*="col-md-"] {
    margin-top: 0;
  }
}
@include media-breakpoint-up(sm) {
  .row.row-grid > [class*="col-sm-"] + [class*="col-sm-"] {
    margin-top: 0;
  }
}

.row-grid + .row-grid {
  margin-top: 3rem;
}


// Negative margins and paddings

@media(min-width: 992px) {
  [class*="mt--"],
  [class*="mr--"],
  [class*="mb--"],
  [class*="ml--"] {

  }


  // Large negative margins in pixels

  .mt--100 {
    margin-top: -100px !important;
  }
  .mr--100 {
    margin-right: -100px !important;
  }
  .mb--100 {
    margin-bottom: -100px !important;
  }
  .ml--100 {
    margin-left: -100px !important;
  }
  .mt--150 {
    margin-top: -150px !important;
  }
  .mb--150 {
    margin-bottom: -150px !important;
  }
  .mt--200 {
    margin-top: -200px !important;
  }
  .mb--200 {
    margin-bottom: -200px !important;
  }
  .mt--300 {
    margin-top: -300px !important;
  }
  .mb--300 {
    margin-bottom: -300px !important;
  }


  // Large margins in pixels

  .pt-100 {
    padding-top: 100px !important;
  }
  .pb-100 {
    padding-bottom: 100px !important;
  }
  .pt-150 {
    padding-top: 150px !important;
  }
  .pb-150 {
    padding-bottom: 150px !important;
  }
  .pt-200 {
    padding-top: 200px !important;
  }
  .pb-200 {
    padding-bottom: 200px !important;
  }
  .pt-250 {
    padding-top: 250px !important;
  }
  .pb-250 {
    padding-bottom: 250px !important;
  }
  .pt-300 {
    padding-top: 300px!important;
  }
  .pb-300 {
    padding-bottom: 300px!important;
  }
}
//
// Shadows
//

// General styles
[class*="shadow"] {
  @if $enable-transitions {
    transition: $transition-base;
  }
}


// Size variations
.shadow-sm--hover:hover {
  box-shadow: $box-shadow-sm !important;
}

.shadow--hover:hover {
  box-shadow: $box-shadow !important;
}

.shadow-lg--hover:hover {
  box-shadow: $box-shadow-lg !important;
}

.shadow-none--hover:hover {
  box-shadow: none !important;
}
// Weight and italics

.font-weight-300 { font-weight: 300 !important; }
.font-weight-400 { font-weight: 400 !important; }
.font-weight-500 { font-weight: 500 !important; }
.font-weight-600 { font-weight: 600 !important; }
.font-weight-700 { font-weight: 700 !important; }
.font-weight-800 { font-weight: 800 !important; }
.font-weight-900 { font-weight: 900 !important; }


// Text decorations

.text-underline { text-decoration: underline; }
.text-through { text-decoration: line-through; }


// Text size

.text-xs { font-size: $font-size-xs !important; }
.text-sm { font-size: $font-size-sm !important; }
.text-lg { font-size: $font-size-lg !important; }
.text-xl { font-size: $font-size-xl !important; }


// Line heights

.lh-100 { line-height: 1; }
.lh-110 { line-height: 1.1; }
.lh-120 { line-height: 1.2; }
.lh-130 { line-height: 1.3; }
.lh-140 { line-height: 1.4; }
.lh-150 { line-height: 1.5; }
.lh-160 { line-height: 1.6; }
.lh-170 { line-height: 1.7; }
.lh-180 { line-height: 1.8; }


// Letter spacings

.ls-1 { letter-spacing: .0625rem; }
.ls-15 { letter-spacing: .09375rem; }
.ls-2 { letter-spacing: 0.125rem; }

// Color variations

@each $color, $value in $colors {
  @include text-emphasis-variant(".text-#{$color}", $value);
}

//
// Tranform
//


@include media-breakpoint-up(lg) {
  .transform-perspective-right {
    transform: scale(1) perspective(1040px) rotateY(-11deg) rotateX(2deg) rotate(2deg);
  }
  .transform-perspective-left{
    transform: scale(1) perspective(2000px) rotateY(11deg) rotateX(2deg) rotate(-2deg)
  }
}
